using System;
using System.Text;
using System.Runtime.InteropServices;

namespace PCI_DIO
{
    public class CPCI_DIO
    {

        //Initial

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_open_card")]
        public static extern short CS_PCI_DIO_open_card(ref byte nDeviceCount);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_close")]
        public static extern void CS_PCI_DIO_close();

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_get_card_no")]
        public static extern short CS_PCI_DIO_get_card_no(byte nDeviceNo,ref ushort nCardNo);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_get_fpga_version")]
        public static extern short CS_PCI_DIO_get_fpga_version(byte nCardNo,ref ushort nVersion);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_get_hardware_id")]
        public static extern short CS_PCI_DIO_get_hardware_id(byte nCardNo,ref ushort nDeviceID);


        //DIO

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_set_single_output")]
        public static extern short CS_PCI_DIO_set_single_output(byte nCardNo, ushort nbit, ushort onoff);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_get_single_output")]
        public static extern short CS_PCI_DIO_get_single_output(byte nCardNo, ushort nbit, ref ushort onoff);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_get_single_input")]
        public static extern short CS_PCI_DIO_get_single_input(byte nCardNo, ushort nbit, ref ushort onoff);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_set_output")]
        public static extern short CS_PCI_DIO_set_output(byte nCardNo, ushort nport, byte value);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_get_output")]
        public static extern short CS_PCI_DIO_get_output(byte nCardNo, ushort nport,ref byte value);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_get_input")]
        public static extern short CS_PCI_DIO_get_input(byte nCardNo, ushort nport,ref byte value);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_set_output_error_handle")]
        public static extern short CS_PCI_DIO_set_output_error_handle(byte nCardNo, ushort onoff);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_get_output_error_handle")]
        public static extern short CS_PCI_DIO_get_output_error_handle(byte nCardNo,ref ushort onoff);


        //PCI_DIO_Interrupt

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_int_control")]
        public static extern short CS_PCI_DIO_int_control(byte nCardNo,ushort enable);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_set_int_factor")]
        public static extern short CS_PCI_DIO_set_int_factor(byte nCardNo,ushort int_factor);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_get_int_factor")]
        public static extern short CS_PCI_DIO_get_int_factor(byte nCardNo,ref ushort int_factor);

        public delegate void PCI_DIO_Callback(byte nCardNo);
        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_link_interrupt")]
        public static extern short CS_PCI_DIO_link_interrupt(byte nCardNo,PCI_DIO_Callback Callback);
        
        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_get_int_status")]
        public static extern short CS_PCI_DIO_get_int_status(byte nCardNo,ref ushort int_status);

        [DllImport("PCI_DIO.dll", EntryPoint = "_PCI_DIO_get_int_io_control")]
        public static extern short CS_PCI_DIO_get_int_io_control(byte nCardNo,ref ushort io_control);


    }
}
