// PCI_DIO_IODlg.cpp : implementation file
//

#include "stdafx.h"
#include "PCI_DIO_IO.h"
#include "PCI_DIO_IODlg.h"
#include <MATH.H>

/* Include files */
#include "PCI_DIO.h"
#include "PCI_DIO_Error.h"
#include "TYPE_DEF.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/*PCI_DIO*/
const unsigned short PCI_DIO_MaxAxesNum = 12;
U8 ExistIOCards = 0;
U8 PCI_DIO_CardNo = 0;
U16 DIO_CardNo;
CString XX;		
bool gbIsTimer = false;		
U16 PCI_DIO_CardNoList[PCI_DIO_MaxAxesNum] = {0};					
/////////////////////////////////////////////////////////////////////////////
// CPCI_DIO_IODlg dialog

CPCI_DIO_IODlg::CPCI_DIO_IODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPCI_DIO_IODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPCI_DIO_IODlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPCI_DIO_IODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPCI_DIO_IODlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPCI_DIO_IODlg, CDialog)
	//{{AFX_MSG_MAP(CPCI_DIO_IODlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_OPEN_CARD, OnBtnOpenCard)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHK_TIMER, OnChkTimer)
	ON_CBN_SELCHANGE(IDC_CmbCardNo, OnEditchangeCmbCardNo)			
	ON_BN_CLICKED(IDC_DIO_Output_BUTTON, OnDIOOutputBUTTON)
	ON_BN_CLICKED(IDC_Error_Handle_CHECK, OnErrorHandleCHECK)
	//}}AFX_MSG_MAP
	
	//ON_CONTROL_RANGE
	ON_CONTROL_RANGE(BN_CLICKED, IDC_CHK_OUTPUT_0, IDC_CHK_OUTPUT_31, OnOutput)
	ON_CONTROL_RANGE(BN_CLICKED,DO_0,DO_7,OnOutPort0)
	ON_CONTROL_RANGE(BN_CLICKED,DO_8,DO_15,OnOutPort1)
	ON_CONTROL_RANGE(BN_CLICKED,DO_16,DO_23,OnOutPort2)
	ON_CONTROL_RANGE(BN_CLICKED,DO_24,DO_31,OnOutPort3)


	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCI_DIO_IODlg message handlers

BOOL CPCI_DIO_IODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CComboBox *CComboBox;							

	// TODO: Add extra initialization here

	SetDlgItemText(IDC_EDT_EXIST_CARD, "0");
	SetDlgItemText(IDC_DIO_Output_EDIT, "0");


	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPCI_DIO_IODlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPCI_DIO_IODlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPCI_DIO_IODlg::OnBtnOpenCard() 
{
	I16 rt;
	U16 i, j,CardNo, fpga_version,DeviceID, SlotID = 0,CardNum;
	U32 DeviceType, IdentityObject;
	U32 lMask = 0x1;

	KillTimer(0);//
	CButton* lpBtnPtr;

	((CButton*)GetDlgItem(IDC_CHK_TIMER))->SetCheck(0);

	((CComboBox*)GetDlgItem(IDC_CmbCardNo))->ResetContent();	
		
	lpBtnPtr = (CButton *)GetDlgItem(IDC_CHK_TIMER);			
	lpBtnPtr->SetCheck(0);										
	lpBtnPtr = (CButton *)GetDlgItem(IDC_CHK_TIMER);			
	lpBtnPtr->EnableWindow(false);			
	


	rt = _PCI_DIO_open_card(&ExistIOCards);//Open IO Card
    if(ExistIOCards == 0)
        AfxMessageBox("PCI-DIO card cant be found!");
    else 
	{
		SetDlgItemInt(IDC_EDT_EXIST_CARD, ExistIOCards, true);
		
		for(i=0; i<ExistIOCards; i++) 
		{

			rt = _PCI_DIO_get_card_no(i, &CardNo);//Get IO_CardNo
			PCI_DIO_CardNoList[i] = CardNo;
			
			if(rt != 0) AfxMessageBox("Can't boot PCI_DIO Master Card!");
			else
			{
				XX.Format("%d",PCI_DIO_CardNoList[i]);
				((CComboBox*)GetDlgItem(IDC_CmbCardNo))->AddString(XX);
				CardNum++;
			}
		}
		if(CardNum!=0)
		{
			((CComboBox*)GetDlgItem(IDC_CmbCardNo))->SetCurSel(0);					
			((CComboBox*)GetDlgItem(IDC_CmbCardNo))->GetWindowText(XX);				
			DIO_CardNo=atoi(XX);
			PCI_DIO_CardNo = atoi(XX);
			((CButton*)GetDlgItem(IDC_CmbCardNo))->EnableWindow(TRUE);	
			
			
			for(i=0;i<32;i++)
			{
				lpBtnPtr = (CButton *)GetDlgItem(DO_0+i);					
				lpBtnPtr->EnableWindow(true);
			}

		}
	}

	((CButton*)GetDlgItem(IDC_CHK_TIMER))->EnableWindow(TRUE);
	SetTimer(0, 20, NULL);
}

void CPCI_DIO_IODlg::OnOK() 
{
	KillTimer(0);//close Timer 0

	_PCI_DIO_close();//close IO card

	CDialog::OnOK();

}

void CPCI_DIO_IODlg::OnTimer(UINT nIDEvent) 
{
	CString xx;
	I16 rt,i;
	unsigned short input_chk;
	unsigned short fpga_version, DeviceID;
	unsigned char output_value;
	unsigned long output_value_long,output_value_temp;
	unsigned char input_value;
	unsigned long input_value_long,input_value_temp;
	unsigned short errorhandle_Onoff;
	output_value_long = 0;
	input_value_long = 0;
	
	if(gbIsTimer) 
	{
			rt = _PCI_DIO_get_fpga_version(PCI_DIO_CardNo, &fpga_version);//Get FPGA_version
			XX.Format("0x%x",fpga_version);
			SetDlgItemText(IDC_EDT_VERSION, XX);

			rt = _PCI_DIO_get_hardware_id(PCI_DIO_CardNo, &DeviceID);//Get HardwareID
			XX.Format("0x%x",DeviceID);
			SetDlgItemText(IDC_EDT_Hardware_ID, XX);
			
			for(i=0;i<4;i++)
			{
				rt = _PCI_DIO_get_output(PCI_DIO_CardNo, i, &output_value);//Get output value
				output_value_temp = 0;
				output_value_temp = output_value;
				output_value_temp = output_value_temp << (i*8);
				output_value_long |= output_value_temp;
																	
				rt = _PCI_DIO_get_input(PCI_DIO_CardNo, i, &input_value);//Get input value
				input_value_temp = 0;
				input_value_temp = input_value;
				input_value_temp = input_value_temp << (i*8);
				input_value_long |= input_value_temp;
			}

			XX.Format("0x%x",output_value_long);
			SetDlgItemText(IDC_DIO_Output_Status, XX);

			XX.Format("0x%x",input_value_long);
			SetDlgItemText(IDC_EDT_Input_Status, XX);
			
			for(i=0;i<32;i++)
			{
				//display input Edit Box
				rt = _PCI_DIO_get_single_input(PCI_DIO_CardNo, i, &input_chk);
				XX.Format("%x",input_chk);
				SetDlgItemText(IN_0+i, XX);
			}

			//Error Handle
			//error handle
			rt = _PCI_DIO_get_output_error_handle(PCI_DIO_CardNo, &errorhandle_Onoff);
			xx.Format("%d",errorhandle_Onoff);		
			SetDlgItemText(IDC_EDT_Error_handle, xx);



	}
	
	CDialog::OnTimer(nIDEvent);
}

void CPCI_DIO_IODlg::OnChkTimer() 
{	
	int chk;
	CButton *lpBtnPtr;
	chk=((CButton*)GetDlgItem(IDC_CHK_TIMER))->GetCheck();
	
	if(chk==1)
	{
		gbIsTimer=true;
	}
	else
	{
		gbIsTimer=false;
	}
}


void CPCI_DIO_IODlg::OnEditchangeCmbCardNo() 
{
	CButton* lpBtnPtr;
				
	((CComboBox*)GetDlgItem(IDC_CmbCardNo))->GetCurSel();			
	((CComboBox*)GetDlgItem(IDC_CmbCardNo))->GetWindowText(XX);		
	PCI_DIO_CardNo=atoi(XX);//Update combobox change CardNo	
	OnChkTimer();
	
}

void CPCI_DIO_IODlg::OnOutput(UINT nID)
{


}

void CPCI_DIO_IODlg::OnOutPort0(UINT nID)
{
	CButton *lpBtnPtr;
	I16 rt,chk,i;

	for(i=0; i<8; i++) 
	{
		chk=((CButton*)GetDlgItem(DO_0+i))->GetCheck();
		rt = _PCI_DIO_set_single_output(PCI_DIO_CardNo, i, chk);
	}
	
}

void CPCI_DIO_IODlg::OnOutPort1(UINT nID)
{
	CButton *lpBtnPtr;
	I16 rt,chk,i;

	for(i=0; i<8; i++) 
	{
		chk=((CButton*)GetDlgItem(DO_8+i))->GetCheck();
		rt = _PCI_DIO_set_single_output(PCI_DIO_CardNo, i+8, chk);
	}

}

void CPCI_DIO_IODlg::OnOutPort2(UINT nID)
{
	CButton *lpBtnPtr;
	I16 rt,chk,i;
	
	for(i=0; i<8; i++) 
	{
		chk=((CButton*)GetDlgItem(DO_16+i))->GetCheck();
		rt = _PCI_DIO_set_single_output(PCI_DIO_CardNo, i+16, chk);
	}

}

void CPCI_DIO_IODlg::OnOutPort3(UINT nID)
{
	CButton *lpBtnPtr;
	I16 rt,chk,i;

	for(i=0; i<8; i++) 
	{
		chk=((CButton*)GetDlgItem(DO_24+i))->GetCheck();
		rt = _PCI_DIO_set_single_output(PCI_DIO_CardNo, i+24, chk);
	}
		
}

void CPCI_DIO_IODlg::OnDIOOutputBUTTON() 
{
	I16 rt,i;
	unsigned long out_value_box;
	unsigned char out_value;
		
	((CEdit*)GetDlgItem(IDC_DIO_Output_EDIT))->GetWindowText(XX);
	
	out_value_box = strtoul(XX.GetBuffer(0), NULL, 16);

	for(i=0;i<4;i++)
	{
		out_value = 0;
		out_value = out_value_box >> (i*8);
		rt = _PCI_DIO_set_output(PCI_DIO_CardNo,i,out_value);
	}
	
}

void CPCI_DIO_IODlg::OnErrorHandleCHECK() 
{
	I16 rt,chk;
	chk =((CButton*)GetDlgItem(IDC_Error_Handle_CHECK))->GetCheck();
	rt = _PCI_DIO_set_output_error_handle(PCI_DIO_CardNo, chk);
}
